--         -----------------------------------------------------------------------
--        |  TinyMeleeStats by TheVaan                                            |
--        |  based on TinyMeleeStats by Sideshow (Draenor EU)   |
--         -----------------------------------------------------------------------

TinyMeleeStats = {};
TinyMeleeStats.Font = "Fonts/Vera.ttf";
TinyMeleeStats.Size = 10;
TinyMeleeStats.Style = 1;
--TinyMeleeStats.FrameMovable = 1;
TinyMeleeStats.Action = true;

local function TMS_config(msg)
    local cmds
    if msg == "" then
        DEFAULT_CHAT_FRAME:AddMessage("|cffffd700~TinyMeleeStats v0.1.1~\nKonfigurationsbefehle:\n|c00ff00ff/tms\n    |c001E90FFfont |cff00ff00[|rSchriftart|cff00ff00]|cffffd700 Schriftart wechseln\n    |c001E90FFlock |cff00ff00[|ron|cff00ff00|||roff|cff00ff00]|cffffd700 Text fixieren/freistellen|r");
    else
		local tCmds, sCmd = {}

		for sCmd in string.gmatch(msg,"%w+") do
			table.insert(tCmds,string.lower(sCmd))
		end
		if (tCmds[1] == "font") then
			TinyMeleeStats.Font = "Fonts/"..tCmds[2]..".ttf";
			tmsstr:SetFont(""..TinyMeleeStats.Font.."", TinyMeleeStats.Size, "OUTLINE");
		elseif (tCmds[1] == "lock") then
			if (tCmds[2] == "on") then
			--	TinyMeleeStats.FrameMovable = 0;
				DEFAULT_CHAT_FRAME:AddMessage("|cffffd700Die Textzeile ist jetzt fixiert!|r");
				tmsframe:SetMovable(0);
			elseif (tCmds[2] == "off") then
			--	TinyMeleeStats.FrameMovable = 1;
				DEFAULT_CHAT_FRAME:AddMessage("|cffffd700Die Textzeile ist jetzt freigegeben!|r");
				tmsframe:SetMovable(1);
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cffff6060Keine g\195\188ltige Eingabe!\n|c00ff00ff/tms |c001E90FFlock |cff00ff00[|ron|cff00ff00|||roff|cff00ff00]|cffffd700 Text fixieren/freistellen|r");
			end
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cffff6060Keine g\195\188ltige Eingabe!\nKonfigurationsbefehle:\n|c00ff00ff/tms\n    |c001E90FFfont |cff00ff00[|rSchriftart|cff00ff00]|cffffd700 Schriftart wechseln\n    |c001E90FFlock |cff00ff00[on|off]|cffffd700 Text fixieren/freistellen|r");
		end
    end
end

SlashCmdList["TMS"] = TMS_config;
SLASH_TMS1 = "/tms";

local tmsframe = CreateFrame("Frame","tmsframe",UIParent)
tmsframe:SetWidth(100);
tmsframe:SetHeight(15);
tmsframe:SetMovable(1);
tmsframe:EnableMouse(1);
tmsframe:EnableMouseWheel(1);
tmsframe:SetPoint("CENTER", UIParent, "CENTER", -100, -100);
tmsframe:SetFrameStrata("HIGH");

tmsframe:RegisterEvent("PLAYER_ENTERING_WORLD");
tmsframe:RegisterEvent("VARIABLES_LOADED");
tmsframe:RegisterEvent("UNIT_ATTACK_POWER");
tmsframe:RegisterEvent("UNIT_ATTACK_SPEED");
tmsframe:RegisterEvent("UNIT_AURA");
tmsframe:RegisterEvent("UPDATE_SHAPESHIFT_FORMS");
tmsframe:RegisterEvent("UNIT_INVENTORY_CHANGED");
tmsframe:RegisterEvent("UNIT_LEVEL");

tmsframe:SetScript("OnEvent", function() TMS_OnEvent(event, arg1) end)
tmsframe:SetScript("OnUpdate", function() TMS_OnEvent(event, arg1) end)
tmsframe:SetScript("OnMouseDown", function() tmsframe:StartMoving() end);
tmsframe:SetScript("OnMouseUp", function() tmsframe:StopMovingOrSizing() end);
tmsframe:SetScript("OnDragStop", function() tmsframe:StopMovingOrSizing() end);
tmsframe:SetScript("OnMouseWheel", function() changestyle(arg1) end);
 
local tmsstr = tmsframe:CreateFontString();
tmsstr:SetFontObject(GameFontNormal);
tmsstr:SetPoint("CENTER", tmsframe);
tmsstr:SetJustifyH("CENTER");
tmsstr:SetJustifyV("MIDDLE");

DEFAULT_CHAT_FRAME:AddMessage("|cffffd700TinyMeleeStats v0.1.1:\nMit |c00ff00ff/tms|cffffd700 kommst du ins Konfigurationsmen\195\188|r");

function TMS_OnEvent()
	if (event == "VARIABLES_LOADED") then
		if (TinyMeleeStats.Size == nil) then
			TinyMeleeStats.Size = 10;
		end
		if (TinyMeleeStats.Style == nil) then
			TinyMeleeStats.Style = 1;
		end
		tmsstr:SetFont(""..TinyMeleeStats.Font.."", TinyMeleeStats.Size, "OUTLINE");
  	end
  	stats();
end

function stats()
	if ((event == "UNIT_ATTACK_POWER") or (event == "UNIT_ATTACK_SPEED") or (event == "UNIT_STATS") or (TinyMeleeStats.Action == true) or (event == "PLAYER_ENTERING_WORLD")) then
		if (TinyMeleeStats.Style == 1) then
			mainSpeed, offSpeed = UnitAttackSpeed("player");
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			tmsstr:SetText("|c00ffef00"..pow.."|r |c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r |c001E90FF"..string.format("%.2f", mainSpeed).." "..string.format("%.2f", offSpeed).."|r");
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 2) then
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			tmsstr:SetText("|c00ffef00"..pow.."|r");
		elseif (TinyMeleeStats.Style == 3) then
			base, buff, debuff = UnitAttackPower("player");
			pow = base + buff + debuff;
			tmsstr:SetText("|c00ffef00"..pow.."|r |c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r");
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 4) then
			tmsstr:SetText("|c00ff00ff"..string.format("%.2f", GetCritChance("player")).."|r");
			TinyMeleeStats.Action = false;
		elseif (TinyMeleeStats.Style == 5) then
			mainSpeed, offSpeed = UnitAttackSpeed("player");
			tmsstr:SetText("|c001E90FF"..string.format("%.2f", mainSpeed).." "..string.format("%.2f", offSpeed).."|r");
			TinyMeleeStats.Action = false;
		end
	end
end

function changestyle(arg1)
	if (arg1 == 1) then
		TinyMeleeStats.Style = TinyMeleeStats.Style + 1;
		if (TinyMeleeStats.Style > 5) then
			TinyMeleeStats.Style = 5;
		end
		TinyMeleeStats.Action = true;
	else
		TinyMeleeStats.Style = TinyMeleeStats.Style - 1;
		if (TinyMeleeStats.Style < 1) then
			TinyMeleeStats.Style = 1;
		end
		TinyMeleeStats.Action = true;
	end
end
